SystemOrganization addCategory: #'GT-SUnitDebugger'!

!Dictionary methodsFor: '*GT-SUnitDebugger' stamp: 'AndreiChis 3/26/2014 16:15'!
gtSUnitPrint

	^ String streamContents: [ :aStream | 
		self keysSortedSafely
				do: [:key | aStream print: key;
						 space;
						 nextPutAll: '->';	
						 space;			
						 print: (self at: key);
						 cr]].! !

!String methodsFor: '*GT-SUnitDebugger' stamp: 'AndreiChis 3/26/2014 16:47'!
gtSUnitPrint

	^ self printString! !

GTGenericStackDebugger subclass: #GTSUnitDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SUnitDebugger'!

!GTSUnitDebugger class methodsFor: 'testing' stamp: 'AndreiChis 11/27/2015 18:55'!
availableAutomatically
	"Should this debugger be taken into account when looking for a debugger to handle an exception."
	
	^ true! !

!GTSUnitDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 12/4/2013 12:07'!
defaultTitle

	^ 'SUnit Debugger'! !

!GTSUnitDebugger class methodsFor: 'testing' stamp: 'AndreiChis 11/27/2015 18:20'!
handlesContext: aContext
	| activationPredicate |
	activationPredicate := self sessionClass activationPredicate.
	^ (aContext stackOfSize: self lookupStackSize) 
		detect: [ :ctx | activationPredicate matches: ctx ] 
		 ifFound: [ true ]
		 ifNone: [ false ]! !

!GTSUnitDebugger class methodsFor: 'testing' stamp: 'AndreiChis 11/27/2015 18:20'!
lookupStackSize
	^ 10! !

!GTSUnitDebugger class methodsFor: 'tools registry' stamp: 'AndreiChis 12/31/2013 21:01'!
register

	self registerToolsOn: Smalltalk tools.! !

!GTSUnitDebugger class methodsFor: 'tools registry' stamp: 'AndreiChis 12/4/2013 12:14'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	registry registerDebugger: self withRank: 70.! !

!GTSUnitDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 12/4/2013 12:14'!
sessionClass

	^ GTSUnitDebugSession! !

!GTSUnitDebugger methodsFor: 'accessing context' stamp: 'AndreiChis 11/30/2015 23:31'!
contextToSelectFrom: aSession
	^ aSession testContext! !

!GTSUnitDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 12/1/2015 20:22'!
inspectorDiffIn: aComposite

	^ aComposite tabulator 
		with: [ :aTabulator |
			aTabulator 
				column: #actual;
				column: #expected.
			aTabulator when: [ self session isActive ].
			aTabulator transmit to: #actual; andShow: [ :anotherComposite |
				anotherComposite  dynamic 
					display: [:anObject |
				 		(GTDebuggerInspector new 
							startOn: self session actualResult) ] ].
			aTabulator transmit to: #expected; andShow: [ :anotherComposite |
				anotherComposite  dynamic 
					display: [:anObject |
				 		(GTDebuggerInspector new 
							startOn: self session expectedResult) ] ] ]! !

!GTSUnitDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 12/1/2015 20:07'!
inspectorIn: aComposite

	(self textualDiffIn: aComposite) title: 'Diff (actual vs. expected)'.
	(self inspectorDiffIn: aComposite) title: 'Objects (actual vs. expected)'.
	(super inspectorIn: aComposite) title: 'Inspector'! !

!GTSUnitDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 12/1/2015 20:04'!
textualDiffIn: composite

	^ composite diff
			when: [ self session isActive ];
			display: [ 
				{self session actualResult gtSUnitPrint. self session expectedResult gtSUnitPrint} ]! !

!GTSUnitDebugger methodsFor: 'updating' stamp: 'AndreiChis 11/30/2015 23:32'!
updateBrowser

	super updateBrowser.
	"The transmission will select the context of the test case. 
	This should only happen the first time.
	Should find another solution so this method doesn;t have to be overridden"
	((self browser paneNamed: #stack) port: #selection) value: self session interruptedContext! !

DebugSession subclass: #GTSUnitDebugSession
	instanceVariableNames: 'assertionContext expectedResult actualResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SUnitDebugger'!

!GTSUnitDebugSession class methodsFor: 'accessing' stamp: 'AndreiChis 12/4/2013 12:24'!
activationPredicate

	^  GTSUnitActivationPredicate new! !

!GTSUnitDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 12/17/2013 11:08'!
actualResult
	
	^ actualResult! !

!GTSUnitDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 12/17/2013 11:08'!
expectedResult
	
	^ expectedResult! !

!GTSUnitDebugSession methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/17/2013 11:12'!
isActive

	^ self isActive: self testContext! !

!GTSUnitDebugSession methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/17/2013 11:11'!
isActive: aContext

	^ aContext 
		ifNil: [ false ] 
		ifNotNil: [ 
			aContext isDead not and: [
				aContext ~= self process suspendedContext or: [aContext willReturn not ] ] ]! !

!GTSUnitDebugSession methodsFor: 'initialization' stamp: 'AndreiChis 12/17/2013 11:08'!
process: aProcess context: aContext

	super process: aProcess context: aContext.
	
	assertionContext ifNil: [
		assertionContext := aContext findContextMatchingPredicate: self class activationPredicate.
		actualResult := assertionContext tempAt: 1.
		expectedResult := assertionContext tempAt: 2]! !

!GTSUnitDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 12/4/2013 13:02'!
testContext

	^ assertionContext sender! !

ContextPredicate subclass: #GTSUnitActivationPredicate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SUnitDebugger'!

!GTSUnitActivationPredicate methodsFor: 'testing' stamp: 'AndreiChis 12/4/2013 12:19'!
matchContext: aContext
	
	^ aContext selector == #assert:equals:! !

TestCase subclass: #GTSUnitExampleFailingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SUnitDebugger'!

!GTSUnitExampleFailingTest class methodsFor: 'testing' stamp: 'AndreiChis 1/19/2014 13:32'!
isAbstract
	^ true! !

!GTSUnitExampleFailingTest class methodsFor: 'testing' stamp: 'AndreiChis 11/27/2015 18:14'!
isUnitTest
	^ false! !

!GTSUnitExampleFailingTest methodsFor: 'tests' stamp: 'AndreiChis 3/26/2014 16:02'!
testArrays
	 self
           assert: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22
23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 
49 50 51 51 51 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 
75 76 77 78 79 80 81 81 81 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99)
           equals: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 
23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 
49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 
75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99)! !

!GTSUnitExampleFailingTest methodsFor: 'tests' stamp: 'AndreiChis 3/26/2014 16:17'!
testDictionary
	 self
		assert: (#(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22
23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 
49 50 51 51 51 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 
75 76 77 78 79 80 81 81 81 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101) inject: Dictionary new into: [ :dict :nr| dict at: nr put: nr<<5. dict ])
      equals: (#(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 
23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 
49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 
75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101) inject: Dictionary new into: [ :dict :nr| 
		nr\\40 == 0 
			ifTrue: [ dict at: nr put: nr<<6 ]
			ifFalse: [ dict at: nr put: nr<<5 ].
			dict ])! !

!GTSUnitExampleFailingTest methodsFor: 'tests' stamp: 'AndreiChis 3/26/2014 16:01'!
testFailingDate
	|aDateAndTime|

	aDateAndTime :=  DateAndTime localTimeZone: TimeZone default; dosEpoch.
	self 
		assert: (aDateAndTime offset: '0:12:00:00')  
		equals: '1 January 1980 1:00 pm' asDateAndTime! !

!GTSUnitExampleFailingTest methodsFor: 'tests' stamp: 'AndreiChis 12/29/2013 18:28'!
testFailingText

	self assert: 'I like pie  
pizza pie 
apple pie 
rad squared pi 
and other PIes'
	equals: 'I like pie  
pizza pie 
potato pie 
rad squared pi 
and other PIes'! !

!GTSUnitExampleFailingTest methodsFor: 'tests' stamp: 'AndreiChis 12/17/2013 10:50'!
testMultiValuedStreaming
	| headers keysAndValues |
	headers := ZnHeaders new.
	headers at: 'Set-Cookie' put: 'foo=1'.
	headers at: 'Set-Cookie' add: 'bar=1'.
	headers at: 'Content-TYPE' put: 'text/plain'.
	headers at: 'Content-Length' put: '128'.
	keysAndValues := OrderedCollection streamContents: [ : stream |
		headers headersDo: [ :key :value |
			stream nextPut: key; nextPut: value ] ].
	self assert: keysAndValues equals: #('Set-Cookie' 'foo=1' 'Set-Cookie' 'bar=1' 'Content-Length' '128' 'Content-TYPE' 'text/plain') asOrderedCollection 
	
	! !

!DateAndTime methodsFor: '*GT-SUnitDebugger' stamp: 'AndreiChis 3/26/2014 15:57'!
gtSUnitPrint

	^ String streamContents: [:s | self printSeparateDateAndTimeOn: s]! !

!Collection methodsFor: '*GT-SUnitDebugger' stamp: 'AndreiChis 3/26/2014 16:44'!
gtSUnitPrint

	^ String streamContents: [:s | self asStringOn: s delimiter: Character cr asString]! !

!Object methodsFor: '*GT-SUnitDebugger' stamp: 'AndreiChis 3/26/2014 16:49'!
gtSUnitPrint
	"I return a textual representation of the object that is used by the SUnit debugger to compare objects using a textual diff."
	
	^ self printString! !
